#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <math.h>
using namespace std ;
using ll = long long ;
using pt = pair<double, double> ;
vector<pt> pts ;
ll n, m ;
ll side(int a, int b, int c) {
   return (pts[b].second - pts[a].second) * (pts[c].first - pts[a].first) -
          (pts[b].first - pts[a].first) * (pts[c].second - pts[a].second) ;
}
double addarea(pt &a, pt &b) {
   if (a == b)
      return 0 ;
   return 0.5 * (a.second + b.second) * (b.first - a.first) ;
}
void rot(pt &a) {
   auto ny = a.first ;
   a.first = n - a.second ;
   a.second = ny ;
}
pt isect(int p1, int p2, int border) {
   pt a = pts[p1] ;
   pt b = pts[p2] ;
   for (int i=0; i<border; i++) {
      rot(a) ;
      rot(b) ;
   }
   pt c = {0, (b.first * a.second - a.first * b.second) / (b.first - a.first)} ;
   for (int i=border; i<4; i++)
      rot(c) ;
   return c ;
}
int main(int argc, char *argv[]) {
   cin >> n >> m ;
   cout << setprecision(15) ;
   pts.resize(m+4) ;
   for (int i=0; i<m; i++)
      cin >> pts[i].first >> pts[i].second ;
   pts[m+1].second = n ;
   pts[m+2].first = n ;
   pts[m+2].second = n ;
   pts[m+3].first = n ;
   double best = -1e30 ;
   for (int r=0; r<4; r++) {
      for (int i=0; i<m; i++)
         rot(pts[i]) ;
      for (int i=0; i<m; i++)
         if (pts[i].first * 2 <= n && pts[i].second * 2 <= n) {
            double crit = 2 * pts[i].first * pts[i].second ;
            double area = crit / (double)(n*n) ;
            int cnt = 0 ;
            for (int j=0; j<m; j++)
               if (pts[j].first * pts[i].second + pts[j].second * pts[i].first <= crit)
                  cnt++ ;
            double t = cnt / (double)m - area ;
            best = max(t, best) ;
         }
   }
   for (int i=0; i<m; i++) {
      vector<pair<double, int>> sortme ;
      for (int j=0; j<m; j++)
         if (i != j)
            sortme.push_back({atan2(pts[j].second-pts[i].second,
                                    pts[j].first-pts[i].first), j}) ;
      sort(sortme.begin(), sortme.end()) ;
      int el = sortme.size() ;
      int k = 0 ;
      for (int j=0; j<el; j++) {
         if ((k + 1 + el - j) % el == 0) // previous was all; advance
            k = (k + 1) % el ;
         if (k == j) // always include first point
            k = (k + 1) % el ;
         while (k != j) {
            int s = side(i, sortme[j].second, sortme[k].second) ;
            if (s <= 0) {
               k = (k + 1) % el ;
            } else
               break ;
         }
         int cnt = 2 + (k + el - j - 1) % el ;
         double area = 0 ;
         if (pts[i].second == pts[sortme[j].second].second) {
            if (pts[i].first < pts[sortme[j].second].first) {
               area = pts[i].second / (double)n ;
            } else {
               area = 1 - pts[i].second / (double)n ;
            }
         } else if (pts[i].first == pts[sortme[j].second].first) {
            if (pts[i].second < pts[sortme[j].second].second) {
               area = 1 - pts[i].first / (double)n ;
            } else {
               area = pts[i].first / (double)n ;
            }
         } else {
            int pc = 0 ;
            while (side(i, sortme[j].second, m+pc) <= 0)
               pc++ ;
            int previ = m+pc ;
            pt prev = pts[previ] ;
            pt nx ;
            area = 0 ;
            int didvec = 0 ;
            for (int k=1; k<=4; k++) {
               int nxi = m+((pc+k)%4) ;
               ll t = side(i, sortme[j].second, nxi) ;
               switch (didvec) {
case 0:
                  if (t <= 0) {
                     nx = isect(i, sortme[j].second, (pc+k+3)%4) ;
                     didvec = 1 ;
                  } else {
                     nx = pts[nxi] ;
                  }
                  break ;
case 1:
                  if (t > 0) {
                     nx = isect(i, sortme[j].second, (pc+k+3)%4) ;
                     area += addarea(prev, nx) ;
                     prev = nx ;
                     previ = nxi ;
                     nx = pts[nxi] ;
                     didvec = 2 ;
                  } else {
                     nx = prev ;
                  }
                  break ;
case 2:
                  if (t < 0) {
                     cout << "Fail" << endl ;
                  } else {
                     nx = pts[nxi] ;
                  }
                  break ;
               }
               area += addarea(prev, nx) ;
               prev = nx ;
               previ = nxi ;
            }
            area /= (double)(n*n) ;
         }
         area = 1 - area ;
// cout << "Cnt is " << cnt << " area is " << area << endl ;
         double t = cnt / (double)m - area ;
         best = max(t, best) ;
         while (j + 1 < el&& side(i, sortme[j].second, sortme[(j+1)%el].second) == 0)
            j++ ;
      }
   }
   cout << best << endl ;
}
